﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Media;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Diagrams.Primitives;
using Telerik.Windows.Diagrams.Core;
using Telerik.Windows.Controls.Diagrams;
using Telerik.Windows.Controls;

namespace DiagramCustomGroups
{
	public class MyGroupsAdorner : GroupsAdorner
	{
		protected override void PrepareContainerForItemOverride(System.Windows.DependencyObject element, object item)
		{
			var rect = element as Rectangle;
			rect.Visibility = System.Windows.Visibility.Visible;
			rect.Stroke = Brushes.Red;


			var group = item as Group;
			foreach (var shape in group.Items.OfType<IShape>())
			{
				shape.PropertyChanged += Shape_PropertyChanged;
			}

			this.Dispatcher.BeginInvoke(new Action(() =>
			{
				var newGroupVisual = this.ItemContainerGenerator.ContainerFromItem(group) as FrameworkElement;
				if (newGroupVisual != null)
				{
					SetPosition(newGroupVisual, group);
				}
			}));
		}

		private void Shape_PropertyChanged(object sender, PropertyEventArgs e)
		{
			if (e.PropertyName == "Bounds")
			{
				var shape = sender as IShape;
				if (shape != null)
				{
					var group = shape.ParentGroup as Group;
					if (group != null)
					{
						var groupVisual = this.ItemContainerGenerator.ContainerFromItem(group) as FrameworkElement;
						if (groupVisual != null) SetPosition(groupVisual, group);

                        var parentGroup = group.ParentGroup;
                        while (parentGroup != null)
                        {
                            var parentVisual = this.ItemContainerGenerator.ContainerFromItem(group.ParentGroup) as FrameworkElement;
                            if (parentVisual != null)
                            {                                
                                SetPosition(parentVisual, parentGroup);
                            }

                            parentGroup = parentGroup.ParentGroup;
                        }
					}
				}
			}
		}

		private static void SetPosition(FrameworkElement visualGroup, IGroup group)
		{
			var rect = group.GetBounds();
			if (rect != Rect.Empty) visualGroup.SetLayout(rect);
		}
	}
}
